
#include <stdio.h>
#include <conio.h>
#include <malloc.h>

#include "..\..\include/squall.h"

//-----------------------------------------------------------------------------
//  
//      :  filename -    
//     :   ,    -1   
//-----------------------------------------------------------------------------
unsigned int my_open(const char* filename)
{
   printf("my_open(%s)\n", filename);
   return fopen(filename, "rb");
}

//-----------------------------------------------------------------------------
//    
//      :  handler  -   
//                buffer   -         
//                size     -    
//     :    
//-----------------------------------------------------------------------------
int my_read(unsigned int handler, void* buffer, int size)
{
   printf("my_read(%d, 0x%X, %d)\n", handler, buffer, size);
   if (fread(buffer, size, 1, (FILE*)handler))
      return size;
   return -1;
}

//-----------------------------------------------------------------------------
//   
//      :  handler  -   
//                position -     
//                mode     -   
//     :     
//-----------------------------------------------------------------------------
int my_seek(unsigned int handler, int position, int mode)
{
   printf("my_seek(%d, %d, %d)\n", handler, position, mode);
   fseek((FILE*)handler, position, mode);
   return ftell((FILE*)handler);
}

//-----------------------------------------------------------------------------
//   
//      :  handler  -   
//     :  *
//-----------------------------------------------------------------------------
void my_close(unsigned int handler)
{
   printf("my_close(%d)\n", handler);
   fclose((FILE*)handler);
}

//-----------------------------------------------------------------------------
//  
//      :  size  -   
//     :     ,    0 
//                   
//-----------------------------------------------------------------------------
void* my_alloc(unsigned int size)
{
   printf("my_alloc(%d)\n", size);

   //   
   if (size == 0)
      return 0;
   
   //  
   return (void*)malloc(size);
}

//-----------------------------------------------------------------------------
//  
//      :  ptr   -     
//     :  *
//-----------------------------------------------------------------------------
void my_free(void* ptr)
{
   printf("my_free(0x%X)\n", ptr);
   //  
   if (ptr != 0)
      free(ptr);
}

//-----------------------------------------------------------------------------
//  
//      :  ptr   -     
//     :  *
//-----------------------------------------------------------------------------
int main(int argc, char* argv[])
{
   int   key      = 0;
   int   sample   = 0;

   SQUALL_SetFileCallbacks(my_open, my_seek, my_read, my_close);
   SQUALL_SetMemoryCallbacks(my_alloc, my_free);

   if (SQUALL_Init(0) < 0)
      printf("error init squall!");

   sample = SQUALL_Sample_LoadFile("..\\media\\music.mp3", 0, 0);
   SQUALL_Sample_Play(sample, 0, 0, 1);

   //  
   do
   {
      if (kbhit())
         key = getch();

   } while (key != 27);

   SQUALL_Free();
	return 0;
}
